#include <iostream>

using namespace std;

struct human {
	int number;
	String last_name;
	String first_name;
	int age;
	String country;
	String job;
	String hobby;
	String phone_number;
}; 

template <>
Element<human> *Dynamo<human>::get(const int value)
{
	Element<human> *temp = head;

	while (temp != NULL) {
		if (temp->data->number == value) {
			return temp;
		}
		temp = temp->next;
	}
	return NULL;
}

template <>
Element<human> *Dynamo<human>::get(const wchar_t *str)
{
	Element<human> *temp = head;
	String buf_str(str);

	while (temp != NULL) {
		if (temp->data->last_name == buf_str) {
			return temp;
		}
		temp = temp->next;
	}
	return NULL;
}

template <>
void Element<human>::show()
{
	if (this == NULL) {
		return;
	}
	wcout << L"Номер: " << data->number << endl
		  << L"Фамилия: " << data->last_name << endl
		  << L"Имя: " << data->first_name << endl
		  << L"Возраст: " << data->age << endl
		  << L"Страна: " << data->country << endl
		  << L"Работа: " << data->job << endl
		  << L"Хобби: " << data->hobby << endl
		  << L"Телефон: " << data->phone_number << endl;
}

template <>
void Dynamo<human>::show()
{
	Element<human> *temp = head;

	while (temp != NULL) {
		wcout << temp->data->number << L" "
			  << temp->data->last_name << L" "
			  << temp->data->first_name << L" "
			  << temp->data->age << L" "
			  << temp->data->country << L" "
			  << temp->data->job << L" "
			  << temp->data->hobby << L" "
			  << temp->data->phone_number << endl;
		
		temp = temp->next;
	}
}

template <>
void Dynamo<human>::sort()
{
	if (head) {
		Element<human> *res = head;
		head = head->next;
		res->next = NULL;

		while (head) {
			Element<human> *elem = head;
			head = head->next;

			if (elem->data->number < res->data->number) {
				elem->next = res;
				res = elem;
			} else {
				Element<human> *p = res;

				while (p->next) {
					if (p->next->data->number > elem->data->number) {
						break;
					}

					p = p->next;
				}

				elem->next = p->next;
				p->next = elem;
			}
		}
		head = res;
	}
}

template <>
void Dynamo<human>::sortByName()
{
	if (head) {
		Element<human> *res = head;
		head = head->next;
		res->next = NULL;

		while (head) {
			Element<human> *elem = head;
			head = head->next;

			if (elem->data->last_name < res->data->last_name) {
				elem->next = res;
				res = elem;
			} else {
				Element<human> *p = res;

				while (p->next) {
					if (p->next->data->last_name > elem->data->last_name) {
						break;
					}

					p = p->next;
				}

				elem->next = p->next;
				p->next = elem;
			}
		}
		head = res;
	}
}