#include "String.h"

using namespace std;

String::String()
{
	s = new wchar_t [256];
	s[0] = '\0';
	n = 0;
}

String::String(const wchar_t *input_string)
{
	s = new wchar_t [256];
	s[0] = '\0';
	n = 0;
	append(input_string);
}

String::String(const String &obj)
{
	s = new wchar_t [256];
	s[0] = '\0';
	n = 0;
	append(obj.s);
}

String::~String()
{
	if (s) {
		delete s;
		s = NULL;
	}
}

int String::length()
{
	return n;
}

wchar_t String::at(int index)
{
	return s[index];
}

void String::setchar(int index, wchar_t symbol)
{
	s[index] = symbol;
}

void String::append(const wchar_t *str)
{
	// получаем длину str
	int str_len = 0;
	while (str[str_len] != '\0') {
		str_len++;
	}

	// создаём новую строку с бОльшим размером
	wchar_t *buf = new wchar_t [n + str_len + 1];

	// копируем
	for (int i = 0; i < n; i++) {
		buf[i] = s[i];
	}

	for (int i = n; i < n + str_len; i++) {
		buf[i] = str[i - n];
	}

	n += str_len;
	buf[n] = '\0';

	// удаляем старый объект и присваиваем указателю адрес buf
	delete s;
	s = buf;
}

void String::erase(int start_pos, int end_pos)
{
	end_pos++;

	for (int i = 0; s[i] != '\0'; i++) {
		s[start_pos + i] = s[end_pos + i];
	}

	n -= end_pos - start_pos;
	s[n] = '\0';
}

void String::insert(const wchar_t *str, int index)
{
	// получаем длину str
	int str_len = strlen(str);

	// создаём новую строку с бОльшим размером
	wchar_t *buf = new wchar_t [n + str_len + 1];

	// копируем
	for (int i = 0; i < index; i++) {
		buf[i] = s[i];
	}

	for (int i = 0; i < str_len; i++) {
		buf[i + index] = str[i];
	}

	for (int i = index; i < n; i++) {
		buf[i + str_len] = s[i];
	}

	n += str_len;
	buf[n] = '\0';

	// удаляем старый объект и присваиваем указателю адрес buf
	delete s;
	s = buf;
}

int strlen(const wchar_t *str)
{
	int len = 0;
	while (str[len] != '\0') {
		len++;
	}
	return len;
}

String& String::operator+(String& str)
{
	String *buf = new String;
	buf->append(s);
	buf->append(str.s);
	return *buf;
}

String& String::operator=(const wchar_t *str)
{
	String *buf = new String(str);
	s = buf->s;
	return *buf;
}

bool String::operator==(String& str)
{
	if (n != str.n) {
		return false;
	}

	for (int i = 0; i < n; i++) {
		if (s[i] != str.s[i]) {
			return false;
		}
	}
	return true;
}

bool String::operator!=(String& str)
{
	return !(*this == str);
}

bool String::operator<(String& str)
{
	int min_length = n < str.n ? n : str.n;

	for (int i = 0; i < min_length; i++) {
		if (s[i] == str.s[i]) {
			continue;
		}
		return s[i] < str.s[i];
	}
	return n < min_length;
}

bool String::operator>(String& str)
{
	int min_length = n < str.n ? n : str.n;

	for (int i = 0; i < min_length; i++) {
		if (s[i] == str.s[i]) {
			continue;
		}
		return s[i] > str.s[i];
	}
	return n < min_length;
}

std::wistream& operator>>(std::wistream& in, String& str)
{
	in >> str.s;
	str.n = strlen(str.s);
	return in;
}

std::wostream& operator<<(std::wostream& out, String& str)
{
	out << str.s;
	return out;
}