#include <iostream>
#include <stdio.h>

#ifndef STRING_H
#define STRING_H

#ifdef __WIN32

#define strlen __strlen
#include <windows.h>
#undef strlen

#endif // __WIN32

class String {
public:
	String();
	String(const wchar_t *input_string);
	String(const String &obj);
	~String();

	int length();
	wchar_t at(int index);
	void setchar(int index, wchar_t symbol);
	void append(const wchar_t *str);
	void erase(int start_pos, int end_pos);
	void insert(const wchar_t *str, int index);
	friend int strlen(const wchar_t *str);

	String& operator+(String& str);
	String& operator=(const wchar_t *str);
	bool operator==(String& str);
	bool operator!=(String& str);
	bool operator<(String& str);
	bool operator>(String& str);

	friend std::wistream& operator>>(std::wistream& in, String& str);
	friend std::wostream& operator<<(std::wostream& out, String& str);

private:
	wchar_t *s;
	int n;
};

#endif