#include "String.h"
#include "Dynamo.h"
#include "Human.h"

void backMessage();
void editMessage(Element<human> *current_data, human *input_data);
void inputInteger(const wchar_t *name, int *current_value, int *dest_value);
void inputString(const wchar_t *name, String *current_value, String *dest_value);
bool isNumber(wchar_t *str, int length);
int wtoi(const wchar_t *str);

int main()
{
#ifdef _WIN32
	setlocale(LC_ALL, "Russian");
	SetConsoleCP(1251);
	SetConsoleOutputCP(1251);
#else // _WIN32
	locale::global(locale("ru_RU.UTF-8"));
#endif // _WIN32

	human elem_array[] = {
		{1, L"Путин", L"Владимир", 62, L"Россия", L"Президент", L"Охота", L"79991234567"},
		{2, L"Медведев", L"Дмитрий", 49, L"Россия", L"Председатель правительства", L"Неизвестно", L"79991234567"},
		{3, L"Обама", L"Барак", 53, L"США", L"Президент", L"Неизвестно", L"19991234567"},
		{6, L"Джонстон", L"Дэвид", 73, L"Канада", L"Президент", L"Неизвестно", L"19991234567"},
		{10, L"Гаук", L"Йоахим", 74, L"Германия", L"Президент", L"Неизвестно", L"499991234567"},
		{4, L"Олланд", L"Франсуа", 60, L"Франция", L"Президент", L"Неизвестно", L"339991234567"},
		{7, L"Наполитано", L"Джорджо", 89, L"Италия", L"Президент", L"Неизвестно", L"399991234567"},
		{8, L"Соммаруга", L"Симонетта", 54, L"Швейцария", L"Президент", L"Неизвестно", L"419991234567"},
		{9, L"Нийнистё", L"Саули", 66, L"Финляндия", L"Президент", L"Неизвестно", L"3589991234567"},
		{5, L"Елизавета II", L"Александра", 88, L"Британия", L"Королева", L"Неизвестно", L"449991234567"}
	};

	Dynamo<human> list;

	for (unsigned int i = 0; i < sizeof(elem_array) / sizeof(*elem_array); i++) {
		list.add(elem_array[i]);
	}

	wchar_t input[32];
	int input_menu;

	do {
		wcout << L"Выберите один из пунктов путём ввода цифры:" << endl;
		wcout << L"1 - Найти запись по номеру" << endl;
		wcout << L"2 - Найти запись по фамилии" << endl;
		wcout << L"3 - Удалить запись по номеру" << endl;
		wcout << L"4 - Удалить запись по фамилии" << endl;
		wcout << L"5 - Изменить запись по номеру" << endl;
		wcout << L"6 - Изменить запись по фамилии" << endl;
		wcout << L"7 - Добавить элемент в список" << endl;
		wcout << L"8 - Сортировать список по номеру" << endl;
		wcout << L"9 - Сортировать список по фамилии" << endl;
		wcout << L"10 - Вывести весь список" << endl;
		wcout << L"0 - Выход" << endl;

		wcout << L"Выбор: ";

		wcin.getline(input, 32);
		input_menu = wtoi(input);

		switch (input_menu) {
			case 1:
				{
					int input_number;

					wcout << L"Введи номер записи: ";
					wcin.getline(input, 32);
					input_number = wtoi(input);

					Element<human> *input_elem = list.get(input_number);
					if (input_elem == NULL) {
						wcout << L"Ошибка: элемент под номером '" << input_number << L"' не найден" << endl;
					} else {
						input_elem->show();
					}

					backMessage();
				}
				break;
			case 2:
				{
					wchar_t *input_string = new wchar_t [32];

					wcout << L"Введи фамилию записи: ";
					wcin.getline(input_string, 32);

					Element<human> *input_elem = list.get(input_string);
					if (input_elem == NULL) {
						wcout << L"Ошибка: элемент с фамилией '" << input_string << L"' не найден" << endl;
					} else {
						input_elem->show();
					}

					backMessage();
				}
				break;
			case 3:
				{
					int input_number;

					wcout << L"Введи номер записи: ";
					wcin.getline(input, 32);
					input_number = wtoi(input);

					Element<human> *input_elem = list.get(input_number);
					if (input_elem == NULL) {
						wcout << L"Ошибка: элемент под номером '" << input_number << L"' не найден" << endl;
					} else {
						list.remove(input_elem);
						wcout << L"Элемент удалён" << endl;
					}

					backMessage();
				}
				break;
			case 4:
				{
					wcout << L"Введи фамилию записи: ";
					wcin.getline(input, 32);

					Element<human> *input_elem = list.get(input);
					if (input_elem == NULL) {
						wcout << L"Ошибка: элемент с фамилией '" << input << L"' не найден" << endl;
					} else {
						list.remove(input_elem);
						wcout << L"Элемент удалён" << endl;
					}

					backMessage();
				}
				break;
			case 5:
				{
					int input_number;

					wcout << L"Введи номер записи: ";
					wcin.getline(input, 32);
					input_number = wtoi(input);

					Element<human> *input_elem = list.get(input_number);
					if (input_elem == NULL) {
						wcout << L"Ошибка: элемент под номером '" << input_number << L"' не найден" << endl;
					} else {
						human edit_elem;
						editMessage(input_elem, &edit_elem);

						list.edit(input_elem, edit_elem);

						wcout << L"Элемент отредактирован" << endl;
					}

					backMessage();
				}
				break;
			case 6:
				{
					wcout << L"Введи фамилию записи: ";
					wcin.getline(input, 32);

					Element<human> *input_elem = list.get(input);
					if (input_elem == NULL) {
						wcout << L"Ошибка: элемент с фамилией '" << input << L"' не найден" << endl;
					} else {
						human edit_elem;
						editMessage(input_elem, &edit_elem);

						list.edit(input_elem, edit_elem);

						wcout << L"Элемент отредактирован" << endl;
					}

					backMessage();
				}
				break;
			case 7:
				{
					human input_elem;

					editMessage(NULL, &input_elem);

					list.add(input_elem);

					wcout << L"Запись успешно добавлена" << endl;
					backMessage();
				}
				break;
			case 8:
				list.sort();

				wcout << L"Список отсортирован по номеру" << endl;
				backMessage();
				break;
			case 9:
				list.sortByName();

				wcout << L"Список отсортирован по фамилии" << endl;
				backMessage();
				break;
			case 10:
				list.show();
				backMessage();
				break;
		}
	} while (input_menu != 0);
	return 0;
}

void backMessage()
{
	wcout << endl << L"Для возврата в меню нажмите ввод" << endl;
	wchar_t input[32];
	wcin.getline(input, 32);
}

void editMessage(Element<human> *current_data, human *input_data)
{
	if (current_data == NULL) {
		inputInteger(L"номер", NULL, &input_data->number);
		inputString(L"фамилию", NULL, &input_data->last_name);
		inputString(L"имя", NULL, &input_data->first_name);
		inputInteger(L"возраст", NULL, &input_data->age);
		inputString(L"страну", NULL, &input_data->country);
		inputString(L"работу", NULL, &input_data->job);
		inputString(L"хобби", NULL, &input_data->hobby);
		inputString(L"телефон", NULL, &input_data->phone_number);
	} else {
		inputInteger(L"номер", &current_data->data->number, &input_data->number);
		inputString(L"фамилию", &current_data->data->last_name, &input_data->last_name);
		inputString(L"имя", &current_data->data->first_name, &input_data->first_name);
		inputInteger(L"возраст", &current_data->data->age, &input_data->age);
		inputString(L"страну", &current_data->data->country, &input_data->country);
		inputString(L"работу", &current_data->data->job, &input_data->job);
		inputString(L"хобби", &current_data->data->hobby, &input_data->hobby);
		inputString(L"телефон", &current_data->data->phone_number, &input_data->phone_number);
	}
}

void inputInteger(const wchar_t *name, int *current_value, int *dest_value)
{
	wchar_t input[32];

	do {
		if (current_value == NULL) {
			wcout << L"Введите " << name << ": ";
		} else {
			wcout << L"Введите " << name << " [" << *current_value << "]: ";
		}
		wcin.getline(input, 32);

		if (strlen(input) == 0 && current_value != NULL) {
			*dest_value = *current_value;
			return;
		}
	} while (!isNumber(input, 32));

	*dest_value = wtoi(input);
}

void inputString(const wchar_t *name, String *current_value, String *dest_value)
{
	wchar_t input[32];

	if (current_value == NULL) {
		do {
			wcout << L"Введите " << name << ": ";
			wcin.getline(input, 32);

			*dest_value = input;
		} while (strlen(input) == 0);
	} else {
		wcout << L"Введите " << name << " [" << *current_value << "]: ";
		wcin.getline(input, 32);

		if (strlen(input) == 0) {
			*dest_value = *current_value;
		} else {
			*dest_value = input;
		}
	}
}

bool isNumber(wchar_t *str, int length)
{
	return isdigit(str[0]);
}

int wtoi(const wchar_t *str)
{
	return (int)wcstol(str, 0, 10);
}
